/* ServerContext.c generated by valac, the Vala compiler
 * generated from ServerContext.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <unistd.h>


#define TYPE_SERVER_CONTEXT (server_context_get_type ())
#define SERVER_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERVER_CONTEXT, ServerContext))
#define SERVER_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERVER_CONTEXT, ServerContextClass))
#define IS_SERVER_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERVER_CONTEXT))
#define IS_SERVER_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERVER_CONTEXT))
#define SERVER_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERVER_CONTEXT, ServerContextClass))

typedef struct _ServerContext ServerContext;
typedef struct _ServerContextClass ServerContextClass;
typedef struct _ServerContextPrivate ServerContextPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ServerContext {
	GObject parent_instance;
	ServerContextPrivate * priv;
	SoupServer* server;
	SoupMessage* msg;
	gsize bufsize;
	void* buffer;
	gssize n;
	gint fd;
};

struct _ServerContextClass {
	GObjectClass parent_class;
};


extern gboolean server_context_abort_handler_registered;
gboolean server_context_abort_handler_registered = FALSE;
static gpointer server_context_parent_class = NULL;

GType server_context_get_type (void);
enum  {
	SERVER_CONTEXT_DUMMY_PROPERTY
};
ServerContext* server_context_new (SoupServer* server, SoupMessage* msg, gint fd, gsize bufsize);
ServerContext* server_context_construct (GType object_type, SoupServer* server, SoupMessage* msg, gint fd, gsize bufsize);
void server_context_on_request_aborted (SoupServer* server, SoupMessage* msg, SoupClientContext* client);
static void _server_context_on_request_aborted_soup_server_request_aborted (SoupServer* _sender, SoupMessage* msg, SoupClientContext* client, gpointer self);
void server_context_on_wrote_chunk (SoupMessage* msg);
static void _server_context_on_wrote_chunk_soup_message_wrote_chunk (SoupMessage* _sender, gpointer self);
gboolean server_context_serve_chunk (ServerContext* self);
static gboolean _server_context_serve_chunk_gsource_func (gpointer self);
void server_context_run (ServerContext* self);
void server_context_cleanup (ServerContext* self);
static void server_context_finalize (GObject* obj);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ServerContext* server_context_construct (GType object_type, SoupServer* server, SoupMessage* msg, gint fd, gsize bufsize) {
	ServerContext * self;
	SoupServer* _tmp0_;
	SoupMessage* _tmp1_;
	g_return_val_if_fail (server != NULL, NULL);
	g_return_val_if_fail (msg != NULL, NULL);
	self = (ServerContext*) g_object_new (object_type, NULL);
	self->server = (_tmp0_ = _g_object_ref0 (server), _g_object_unref0 (self->server), _tmp0_);
	self->msg = (_tmp1_ = _g_object_ref0 (msg), _g_object_unref0 (self->msg), _tmp1_);
	self->fd = fd;
	self->bufsize = bufsize;
	return self;
}


ServerContext* server_context_new (SoupServer* server, SoupMessage* msg, gint fd, gsize bufsize) {
	return server_context_construct (TYPE_SERVER_CONTEXT, server, msg, fd, bufsize);
}


static void _server_context_on_request_aborted_soup_server_request_aborted (SoupServer* _sender, SoupMessage* msg, SoupClientContext* client, gpointer self) {
	server_context_on_request_aborted (_sender, msg, client);
}


static void _server_context_on_wrote_chunk_soup_message_wrote_chunk (SoupMessage* _sender, gpointer self) {
	server_context_on_wrote_chunk (_sender);
}


static gboolean _server_context_serve_chunk_gsource_func (gpointer self) {
	return server_context_serve_chunk (self);
}


void server_context_run (ServerContext* self) {
	g_return_if_fail (self != NULL);
	g_object_ref ((GObject*) self);
	g_object_set_data_full ((GObject*) self->msg, "meiga-server-context", (void*) self, NULL);
	if (!server_context_abort_handler_registered) {
		g_signal_connect (self->server, "request-aborted", (GCallback) _server_context_on_request_aborted_soup_server_request_aborted, NULL);
		server_context_abort_handler_registered = TRUE;
	}
	g_signal_connect (self->msg, "wrote-chunk", (GCallback) _server_context_on_wrote_chunk_soup_message_wrote_chunk, NULL);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _server_context_serve_chunk_gsource_func, g_object_ref (self), g_object_unref);
}


void server_context_cleanup (ServerContext* self) {
	g_return_if_fail (self != NULL);
	g_object_set_data_full ((GObject*) self->msg, "meiga-server-context", NULL, NULL);
	if (self->buffer != NULL) {
		g_free (self->buffer);
		self->buffer = NULL;
	}
	if (self->fd > 0) {
		close (self->fd);
		self->fd = -1;
		g_object_unref ((GObject*) self);
	}
}


gboolean server_context_serve_chunk (ServerContext* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->fd <= 0) {
		result = FALSE;
		return result;
	}
	self->buffer = (void*) g_new0 (gchar, self->bufsize);
	self->n = read (self->fd, (void*) self->buffer, self->bufsize);
	if (self->n > 0) {
		soup_message_body_append (self->msg->response_body, SOUP_MEMORY_TAKE, self->buffer, (gsize) self->n);
		soup_server_unpause_message (self->server, self->msg);
	} else {
		soup_message_body_complete (self->msg->response_body);
		soup_server_unpause_message (self->server, self->msg);
		self->buffer = NULL;
		server_context_cleanup (self);
	}
	result = FALSE;
	return result;
}


void server_context_on_wrote_chunk (SoupMessage* msg) {
	ServerContext* sc = NULL;
	g_return_if_fail (msg != NULL);
	sc = (ServerContext*) g_object_get_data ((GObject*) msg, "meiga-server-context");
	if (sc != NULL) {
		server_context_serve_chunk (sc);
	}
}


void server_context_on_request_aborted (SoupServer* server, SoupMessage* msg, SoupClientContext* client) {
	ServerContext* sc = NULL;
	g_return_if_fail (server != NULL);
	g_return_if_fail (msg != NULL);
	g_return_if_fail (client != NULL);
	sc = (ServerContext*) g_object_get_data ((GObject*) msg, "meiga-server-context");
	if (sc != NULL) {
		server_context_cleanup (sc);
	}
}


static void server_context_class_init (ServerContextClass * klass) {
	server_context_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = server_context_finalize;
}


static void server_context_instance_init (ServerContext * self) {
}


static void server_context_finalize (GObject* obj) {
	ServerContext * self;
	self = SERVER_CONTEXT (obj);
	_g_object_unref0 (self->server);
	_g_object_unref0 (self->msg);
	G_OBJECT_CLASS (server_context_parent_class)->finalize (obj);
}


GType server_context_get_type (void) {
	static volatile gsize server_context_type_id__volatile = 0;
	if (g_once_init_enter (&server_context_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ServerContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) server_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServerContext), 0, (GInstanceInitFunc) server_context_instance_init, NULL };
		GType server_context_type_id;
		server_context_type_id = g_type_register_static (G_TYPE_OBJECT, "ServerContext", &g_define_type_info, 0);
		g_once_init_leave (&server_context_type_id__volatile, server_context_type_id);
	}
	return server_context_type_id__volatile;
}




